﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CMA.MovieRentalStore.EnterpriseModel.Repositories;

namespace CMA.MovieRentalStore.EnterpriseModel
{
    public class RentalService
    {
        #region Fields
        private static readonly RentalService SingletonInstance = new RentalService();
        private static MovieRentalDBEntities DatabaseContextInstance;
        #endregion

        #region Constructor
        private RentalService()
        {

        }
        #endregion

        #region Properties
        public static RentalService Current
        {
            get
            {
                return SingletonInstance ?? new RentalService();
            }
        }

        public MovieRentalDBEntities DatabaseContext
        {
            get
            {
                return DatabaseContextInstance;
            }
        }
        #endregion

        #region Methods
        public IRepository<T> GetRepository<T>() where T : IDatabaseEntity
        {
            return RepositoryFactory.GetRepository<T>();
        }

        public void CloseConnection()
        {
            DatabaseContextInstance.Dispose();
        }

        public void Connect()
        {
            DatabaseContextInstance = new MovieRentalDBEntities();
        }
        #endregion
    }
}
