﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CMA.MovieRentalStore.EnterpriseModel.Repositories
{
    internal sealed class MovieRepository : IRepository<DVD>
    {
        #region Methods
        public void Add(DVD entity)
        {
            var existingMovie = RentalService.Current.DatabaseContext.DVD.FirstOrDefault(movie => movie.ID == entity.ID);

            if (existingMovie == null)
            {
                RentalService.Current.DatabaseContext.AddToDVD(entity);
                RentalService.Current.DatabaseContext.SaveChanges();
            }
        }

        public void Update(DVD entity)
        {
            var existingMovie = RentalService.Current.DatabaseContext.DVD.FirstOrDefault(movie => movie.ID == entity.ID);

            if (existingMovie != null)
            {
                existingMovie.Title = entity.Title;
                existingMovie.Price = entity.Price;
                existingMovie.AgeRating = entity.AgeRating;
                RentalService.Current.DatabaseContext.SaveChanges();
            }
        }

        public void Delete(int id)
        {
            var existingMovie = RentalService.Current.DatabaseContext.DVD.FirstOrDefault(movie => movie.ID == id);

            if (existingMovie != null)
            {
                RentalService.Current.DatabaseContext.DVD.DeleteObject(existingMovie);
                RentalService.Current.DatabaseContext.SaveChanges();
            }
        }

        public IEnumerable<DVD> GetAll(Predicate<DVD> condition = null)
        {
            var movies = new List<DVD>();

            if (condition == null)
            {
                movies = RentalService.Current.DatabaseContext.DVD.Include("Rental").ToList();
            }
            else
            {
                foreach (var movie in RentalService.Current.DatabaseContext.DVD.Include("Rental"))
                    if (condition(movie))
                    {
                        movies.Add(movie);
                    }
            }

            return movies;
        }

        public DVD GetEntity(int id)
        {
            var foundMovie = RentalService.Current.DatabaseContext.DVD.Include("Rental").FirstOrDefault(movie => movie.ID == id);
            return foundMovie;
        }
        #endregion
    }
}
