﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using CMA.MovieRentalStore.EnterpriseModel;

namespace CMA.MovieRentalStore.Presentation.Converters
{
    public class PersonConverter : IValueConverter
    {
        #region Methods
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //Konvertiert eine Person in die Darstellung Nachname, Vorname bzw.
            //konvertiert eine Liste von Personen in eine Liste der o.g. Darstellung

            var currentPerson = value as Person;

            if (currentPerson != null)
                return string.Format("{0},{1}", currentPerson.LastName, currentPerson.FirstName);

            var persons = value as IEnumerable<Person>;

            if (persons == null)
                return string.Empty;

            var temporaryPersons = new List<string>();

            foreach (var person in persons)
            {
                temporaryPersons.Add(string.Format("{0},{1}", person.LastName, person.FirstName));
            }

            return temporaryPersons;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
