﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Exercise_10_3
{
    class Program
    {
        static void Main(string[] args)
        {
            string input;

            do
            {
                ShowMenu();

                input = Console.ReadLine();
                Console.WriteLine();

                switch (input)
                {
                    case "1":
                        RunPalindrom();
                        break;
                    case "2":
                        RunCharacterCounter();
                        break;
                    default:
                        Console.WriteLine("Falsche Eingabe. Bitte nochmal wiederholen.");
                        Console.WriteLine();
                        break;
                }
            }
            while (input != "e");
        }

        private static void ShowMenu()
        {
            Console.WriteLine("Welches Programm soll gestartet werden?");
            Console.WriteLine("Palindrom - 1");
            Console.WriteLine("Häufigkeit zählen - 2");
            Console.WriteLine("Beenden - e");
            Console.Write("Eingabe: ");
        }

        private static void RunPalindrom()
        {
            Console.Write("Bitte geben Sie ein Wort ein: ");
            var inputText = Console.ReadLine();

            if (IsPalindrom(inputText))
                Console.WriteLine("Das Wort ist ein Palindrom");
            else
                Console.WriteLine("Das Wort ist kein Palindrom");

            Console.WriteLine();
        }

        private static bool IsPalindrom(string inputText)
        {
            //Empty input
            if (string.IsNullOrEmpty(inputText))
                return false;

            //easier handling ignoring case sensitive words
            inputText = inputText.ToLower();

            var currentLength = inputText.Length - 1;

            //iterate from left and right and check each character for equality
            for (int i = 0; i <= inputText.Length / 2; i++)
            {
                if (inputText[i] != inputText[currentLength])
                    return false;

                currentLength--;
            }

            return true;
        }

        private static void RunCharacterCounter()
        {
            Console.Write("Bitte geben Sie ein Wort ein: ");

            var inputText = Console.ReadLine();

            var filteredCharacters = GetCharacterInfo(inputText);

            Console.WriteLine("Symbol\tHäufigkeit");

            foreach (var characterInfo in filteredCharacters)
                Console.WriteLine("{0}\t{1}", characterInfo.Key, characterInfo.Value);

            Console.WriteLine();
        }

        private static Dictionary<char, uint> GetCharacterInfo(string inputText)
        {
            var filteredCharacters = new Dictionary<char, uint>();

            for (int i = 0; i < inputText.Length; i++)
            {
                if (!filteredCharacters.Keys.Contains(inputText[i]))
                    filteredCharacters.Add(inputText[i], 1);
                else
                    filteredCharacters[inputText[i]]++;
            }
            return filteredCharacters;
        }
    }
}
