﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using Path = System.IO.Path;
using System.Xml.Linq;
using System.Collections.ObjectModel;

namespace Exercise_11
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Movies = new ObservableCollection<Movie>();
        }

        private void LoadMovies_Click(object sender, RoutedEventArgs e)
        {
            LoadMoviesFromStorageFile();

            DataContext = Movies;
        }

        private void LoadMoviesFromStorageFile()
        {
            Movies.Clear();

            //Get application executable path
            var applicationPath = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "Movies.xml");

            //Load file
            var movieStorageFile = XDocument.Load(applicationPath);

            foreach (var movieNode in movieStorageFile.Element("Movies").Elements("Movie"))
            {
                var currentMovie = new Movie
                {
                    Title = movieNode.Element("Title").Value,
                    Description = movieNode.Element("Description").Value,
                    Genre = movieNode.Element("Genre").Value,
                    AgeRating = ushort.Parse(movieNode.Element("AgeRating").Value)
                };

                Movies.Add(currentMovie);
            }
        }

        public ObservableCollection<Movie> Movies
        {
            private set;
            get;
        }
    }
}
