﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows;

namespace WpfPersonDataExampleApplication
{
  public sealed class Person : INotifyPropertyChanged
  {
    private string _name;
    private int _age;

    public string Name
    {
      get
      {
        return _name;
      }
      set
      {
        if(_name != value)
        {
          _name = value;
          OnPropertyChanged("Name");
        }
      }
    }

    public int Age
    {
      get
      {
        return _age;
      }
      set
      {
        if(_age != value)
        {
          _age = value;
          OnPropertyChanged("Age");
        }
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    private void OnPropertyChanged(string propertyName)
    {
      if(PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }


    public void Save()
    {
      using(var fileStream = File.CreateText("C:\\Person.txt"))
      {
        fileStream.WriteLine("Name: " + Name);
        fileStream.WriteLine("Age: " + Age);
        fileStream.Flush();
        fileStream.Close();
      }
    }
  }
}
