﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace Exercise_12
{
    /// <summary>
    /// Interaktionslogik für CustomerView.xaml
    /// </summary>
    public partial class CustomerView : UserControl
    {
        public CustomerView()
        {
            InitializeComponent();
            LoadCustomers();
        }

        private void LoadCustomers()
        {
            using (var context = new BookStoreEntities())
            {
                Customers = new ObservableCollection<Customer>(context.Customer.ToList());
                DataContext = Customers;
            }
        }

        public ObservableCollection<Customer> Customers
        {
            private set;
            get;
        }

        private void ButtonAdd_Click(object sender, RoutedEventArgs e)
        {
            var customer = new Customer { FirstName = TextBoxFirstName.Text, LastName = TextBoxLastName.Text };
            Customers.Add(customer);

            using (var context = new BookStoreEntities())
            {
                context.Customer.AddObject(customer);
                context.SaveChanges();
            }
        }

        private void ButtonUpdate_Click(object sender, RoutedEventArgs e)
        {
            if (ListViewCustomers.SelectedItem != null)
            {
                var selectedCustomer = ListViewCustomers.SelectedItem as Customer;

                using (var context = new BookStoreEntities())
                {
                    var updateableCustomer = context.Customer.FirstOrDefault(aCustomer => aCustomer.ID == selectedCustomer.ID);

                    updateableCustomer.FirstName = TextBoxFirstName.Text;
                    updateableCustomer.LastName = TextBoxLastName.Text;

                    Customers.FirstOrDefault(aCustomer => aCustomer.ID == updateableCustomer.ID).FirstName = TextBoxFirstName.Text;
                    Customers.FirstOrDefault(aCustomer => aCustomer.ID == updateableCustomer.ID).LastName = TextBoxLastName.Text;

                    context.SaveChanges();
                }
            }
        }

        private void MenuItemDelete_Click(object sender, RoutedEventArgs e)
        {
            if (ListViewCustomers.SelectedItem != null)
            {
                var selectedCustomer = ListViewCustomers.SelectedItem as Customer;
                Customers.Remove(selectedCustomer);

                using (var context = new BookStoreEntities())
                {
                    var temporaryCustomer = context.Customer.FirstOrDefault(aCustomer => aCustomer.ID == selectedCustomer.ID);

                    if (temporaryCustomer != null)
                    {
                        foreach (var book in temporaryCustomer.Book)
                        {
                            context.Book.DeleteObject(book);
                            context.SaveChanges();
                        }

                        context.Customer.DeleteObject(temporaryCustomer);
                        context.SaveChanges();
                    }
                }
            }
        }
    }
}
