﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Reflection;

namespace CMA.MovieRentalStore.EnterpriseModel.Logging
{
    public static class ExceptionLogger
    {
        #region Fields
        private static StreamWriter _writeStream;
        #endregion

        #region Methods
        public static void LogException(Exception exception)
        {
            //Schreibt in die bestehende Logdatei die aktuelle Ausnahmeninformation
            _writeStream.WriteLine(string.Format("Current datetime:{0}", DateTime.Now.ToString()));
            _writeStream.WriteLine();
            _writeStream.WriteLine(string.Format("Message:\r\n{0}", exception.Message));
            _writeStream.WriteLine();
            _writeStream.WriteLine(string.Format("Stack trace:\r\n{0}", exception.StackTrace));

            _writeStream.WriteLine();

            if (exception.InnerException != null)
            {
                _writeStream.WriteLine("Inner exception:\r\n\r\n");
                LogException(exception.InnerException);
            }
            else
            {
                _writeStream.WriteLine();
                _writeStream.Flush();
            }
        }

        public static void Start()
        {
            //Erzeugt die Log-Umgebung und initialisiert die Log-Datei
            string applicationPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            string errorLogDirectoryPath = Path.Combine(applicationPath, "ErrorLogs");

            if (!Directory.Exists(errorLogDirectoryPath))
                Directory.CreateDirectory(errorLogDirectoryPath);

            string dayPath = Path.Combine(errorLogDirectoryPath, DateTime.Now.ToShortDateString());

            if (!Directory.Exists(dayPath))
                Directory.CreateDirectory(dayPath);

            _writeStream = new StreamWriter(Path.Combine(dayPath, "Protocol.log"), true);
            _writeStream.WriteLine(string.Format("Log - {0}", DateTime.Now.ToString()));
            _writeStream.WriteLine();
        }

        public static void Stop()
        {
            //Schließt die Datei
            _writeStream.Flush();
            _writeStream.Close();
            _writeStream.Dispose();
        }
        #endregion
    }
}
