﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CMA.MovieRentalStore.EnterpriseModel;

namespace CMA.MovieRentalStore.EnterpriseModel.Repositories
{
    public interface IRepository<T> where T : IDatabaseEntity
    {
        #region Methods
        void Add(T entity);
        void Update(T entity);
        void Delete(int id);
        IEnumerable<T> GetAll(Predicate<T> condition = null);
        T GetEntity(int id);
        #endregion
    }
}
