﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CMA.MovieRentalStore.EnterpriseModel.Repositories
{
    internal static class RepositoryFactory
    {
        #region Methods
        internal static IRepository<T> GetRepository<T>() where T : IDatabaseEntity
        {
            //Erzeugt eine Instanz des entsprechenden Containers und gibt diesen zurück
            var type = typeof(T).Name;

            switch (type)
            {
                case "Person":
                    return (IRepository<T>)Activator.CreateInstance(typeof(PersonRepository));
                case "Rental":
                    return (IRepository<T>)Activator.CreateInstance(typeof(RentalRepository));
                case "DVD":
                    return (IRepository<T>)Activator.CreateInstance(typeof(MovieRepository));
                default:
                    throw new ArgumentException(string.Format("{0} is not a valid type", type));
            }
        }
        #endregion
    }
}
