﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using CMA.MovieRentalStore.EnterpriseModel;
using CMA.MovieRentalStore.EnterpriseModel.Logging;

namespace CMA.MovieRentalStore.Presentation
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        #region Constructor
        public MainWindow()
        {
            InitializeComponent();
            RentalService.Current.Connect();
            ExceptionLogger.Start();
        }
        #endregion

        #region Methods
        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            //Schließt alle nicht-verwalteten Ressourcen, wenn die Anwendung geschlossen wird
            RentalService.Current.CloseConnection();
            ExceptionLogger.Stop();
            base.OnClosing(e);
        }
        #endregion
    }
}
