﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PersonnelManagement
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        PersonnelManagement _personnelManagement;

        public MainWindow()
        {
            InitializeComponent();
            _personnelManagement = new PersonnelManagement();
        }

        private void btnCalculateSalary_Click(object sender, RoutedEventArgs e)
        {
            Person person = GetInitializedPerson();
            txtBxTotalSalary.Text =
            _personnelManagement.CalculateSalary(person).ToString();
        }

        private void btnPromote_Click(object sender, RoutedEventArgs e)
        {
            Person person = GetInitializedPerson();
            IPromotable promotable = null;

            if (person is IPromotable)
            {
                promotable = person as IPromotable;
                txtBxPromotion.Text =
                _personnelManagement.Promote(promotable);
            }
            else
                txtBxPromotion.Text = "Kann nicht befördert werden.";
        }

        private Person GetInitializedPerson()
        {
            string firstName = txtBxFirstName.Text;
            string lastName = txtBxLastName.Text;
            string address = txtBxAddress.Text;
            uint age = uint.Parse(txtBxAge.Text);
            decimal hourlyRate = decimal.Parse(txtBxHourlyRate.Text);

            if (rdbtnPermantEmployee.IsChecked == true) //Überprüfung der 
                //Checked Eigenschaft
                return new PermanentEmployee(firstName, lastName, address, age,
                hourlyRate); //Festangestellter ausgewählt
            else
                return new Freelancer(firstName, lastName, address,
                                      age, hourlyRate);
        }

    }
}
