﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NewsletterConsoleApplication
{
    //Definition des Eventhandler-Delegaten
    public delegate void NewsletterEventHandler(object sender, NewsletterEventArgs e);

    public class CinemaSystem
    {
        //Definition des zu abonnierenden Events
        public event NewsletterEventHandler NewsletterReceived;

        public void CreateNewsletter(string content)
        {
            Newsletter newsletter = new Newsletter(content);

            if (NewsletterReceived != null) //Prüfen auf Abonnierung
            {
                //Auslösen des Ereignisses
                NewsletterReceived(this, new NewsletterEventArgs(newsletter));
            }

        }
    }

}
