﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PersonnelManagement
{
    public sealed class Freelancer : Person, IPromotable
    {
        private readonly decimal _percentageRate;

        public Freelancer(string firstName, string lastName, string address, uint age, decimal hourlyRate) : base(firstName, lastName, address, age, hourlyRate) 
        {
            _percentageRate = 15.0M;
        }

        public override decimal CalculateSalary()
        {
            var totalSalary = base.CalculateSalary();
            return (((_percentageRate / 100) * totalSalary) + totalSalary);
        }

        public string Promote()
        {
            return "Chefentwickler";
        }
    }
}
