﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PersonnelManagement
{
    public abstract class Person
    {
        protected int _daysPerWeek = 5;
        protected int _hoursPerWeek = 40;

        public string FirstName
        {
            private set;
            get;
        }

        public string LastName
        {
            private set;
            get;
        }

        public uint Age
        {
            private set;
            get;
        }

        public string Address
        {
            private set;
            get;
        }

        public decimal HourlyRate
        {
            private set;
            get;
        }

        public override bool Equals(object obj)
        {
          var otherPerson = obj as Person;
          if(otherPerson == null)
            return false;

          return FirstName.Equals(otherPerson.FirstName) && LastName.Equals(otherPerson.LastName) && Age == otherPerson.Age
                 && Address.Equals(otherPerson.Address);
        }

        protected Person(string firstName, string lastName, string address, uint age, decimal hourlyRate)
        {
            FirstName = firstName;
            LastName = lastName;
            Address = address;
            Age = age;
            HourlyRate = hourlyRate;
        }

        public virtual decimal CalculateSalary()
        {
            return (_hoursPerWeek * _daysPerWeek * HourlyRate);
        }

        public override string ToString()
        {
          return string.Format("{0}, {1}",LastName, FirstName);
        }
    }
}
