﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace Exercise_7
{
    public class FriendQueue : IEnumerable<FriendInfo> 
    {
        private List<FriendInfo> _friends;

        public FriendQueue()
        {
            _friends = new List<FriendInfo>();
        }

        public void Enqueue(FriendInfo friendInfo)
        {
            _friends.Add(friendInfo);
        }

        public FriendInfo Dequeue()
        {
            if (_friends.Count > 0)
            {
                var currentFriendInfo = _friends.ElementAt(0);
                _friends.RemoveAt(0);
                return currentFriendInfo;
            }
            else
                return null;
        }

        public bool IsEmpty
        {
            get
            {
                return _friends.Count == 0;
            }
        }


        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public IEnumerator<FriendInfo> GetEnumerator()
        {
            return new FriendQueueEnumerator<FriendInfo>(_friends);
        }

        private class FriendQueueEnumerator<FriendInfo> : IEnumerator<FriendInfo>
        {
            private List<FriendInfo> _friends;
            private int _pointer;

            internal FriendQueueEnumerator(IEnumerable<FriendInfo> queue)
            {
                _friends = new List<FriendInfo>(queue);
                _pointer = -1;
            }

            public object Current
            {
                get { return _friends[_pointer]; }
            }

            public bool MoveNext()
            {
                _pointer++;
                return _pointer < _friends.Count;
            }

            public void Reset()
            {
                _pointer = -1;
            }

            FriendInfo IEnumerator<FriendInfo>.Current
            {
                get { return (FriendInfo)Current; }
            }

            public void Dispose()
            {
                //TODO
            }
        }
    }
}
