﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PersonnelManagement
{
    public abstract class Person
    {
        protected int _daysPerWeek = 5;
        protected int _hoursPerWeek = 40;

        public string FirstName
        {
            private set;
            get;
        }

        public string LastName
        {
            private set;
            get;
        }

        public uint Age
        {
            private set;
            get;
        }

        public string Address
        {
            private set;
            get;
        }

        public decimal HourlyRate
        {
            private set;
            get;
        }

        protected Person(string firstName, string lastName, string address, uint age, decimal hourlyRate)
        {
            FirstName = firstName;
            LastName = lastName;
            Address = address;
            Age = age;
            HourlyRate = hourlyRate;
        }

        public virtual decimal CalculateSalary()
        {
            return (_hoursPerWeek * _daysPerWeek * HourlyRate);
        }

        public override bool Equals(object obj)
        {
            var otherPerson = obj as Person;
            if (otherPerson == null)
                return false;
            return (LastName.Equals(otherPerson.LastName) &&
                    FirstName.Equals(otherPerson.FirstName) &&
                    Age == otherPerson.Age &&
                    Address.Equals(otherPerson.Address));
        }

        public override string ToString()
        {
            return string.Format("{0}, {1}", LastName, FirstName);
        }
    }
}
