﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;
using System.Xml.Linq;

namespace Exercise_8
{
    class Program
    {
        static void Main(string[] args)
        {
            var filePath = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "MyFriends.xml");

            var document = XDocument.Load(filePath);

            List<Friend> friends = new List<Friend>();

            foreach (var friendNode in document.Element("Friends").Elements("Friend"))
            {
                var friend = new Friend();
                friend.FirstName = friendNode.Element("FirstName").Value;
                friend.LastName = friendNode.Element("LastName").Value;
                friend.Age = ushort.Parse(friendNode.Element("Age").Value);
                friend.Address = friendNode.Element("Address").Value;
                friend.Gender = friendNode.Element("Gender").Value.ToUpper().Equals("MALE") ? Gender.Male : Gender.Female;
                friend.Friendship = DateTime.Now.Subtract(DateTime.Parse(friendNode.Attribute("since").Value));

                friends.Add(friend);
            }

            Console.WriteLine("Alle Freunde, deren Wohnort Musterstadt ist:");
            foreach (var friend in friends.Where(candidate => candidate.Address.Contains("Musterstadt")))
                Console.WriteLine(friend);

            Console.WriteLine("Alle Freunde, deren Freundschaft über 5 Jahre beträgt:");
            foreach (var friend in friends.Where(candidate => candidate.Friendship.Days >= (5*365)))
                Console.WriteLine(friend);

            Console.WriteLine("Anzahl der Freunde:");
                Console.WriteLine(friends.Count);

                Console.WriteLine();

            Console.WriteLine("Alle Freunde, die beste Freunde sind:");
                Console.WriteLine(friends.FirstOrDefault(aFriend => aFriend.Friendship.Equals(friends.Max((candidate) => candidate.Friendship))));

            Console.ReadKey();
        }
    }
}
